with Chop;
with Global; use global;

procedure Dining_Philosophers is

   task type Philosopher is
   		entry GetId(Get_Unique : in Id);
   end Philosopher;
	
   task body Philosopher is
	  Self : Id ;
   begin
	  accept GetId(Get_Unique : in Id) 
		do Self := Get_Unique; end GetId;
      loop
         -- Thinking; 
         Chop.Get_LR(Self);
         -- Eating;
         Chop.Release(Self);
         -- Quitting;
      end loop;
   end Philosopher;

   Philosophers : array (Id) of Philosopher;

begin
   for I in Id loop Philosophers(I).GetId(I); end loop;
end Dining_Philosophers;

